Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization

Namespace PSP
    ''' ۑF01A
    '''     ςƕW΍
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    Public Class C01A
#If C01A Then
       Shared Sub Main(ByVal args() As String)
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "01A", AddressOf Main, False)
                Exit Sub
            End If
            Dim l As LinkList = New LinkList()
            If (Not ReadData(args(0), l)) Then Return
            Dim ave, std As Double
            Calc(l, ave, std)
            Console.WriteLine("{0:F2} {1:F5}", ave, std)
        End Sub
#End If
        ''' t@Cf[^Ǎ݂܂B
        Public Shared Function ReadData(ByVal fnam As String, ByVal l As LinkList)
            Dim data() As Double
            Try ' t@CJ
                Dim xr As XmlSerializer = New XmlSerializer(GetType(Double()))
                Dim sr As StreamReader = New StreamReader(fnam)
                data = CType(xr.Deserialize(sr), Double())
                sr.Close()
            Catch e As FileNotFoundException
                Console.Error.WriteLine(e.Message)
                Return False
            End Try
            Dim d As Double
            For Each d In data
                l.Add(d)
            Next
            Return True
        End Function
        ''' ςƕW΍vZ܂B
        Public Shared Sub Calc(ByVal l As LinkList, ByRef ave As Double, ByRef std As Double)
            ave = 0
            std = 0
            Dim d As Double
            For Each d In l
                ave += d
                std += d * d
            Next
            ave /= Math.Max(1, l.Count)
            std = Math.Sqrt((std - ave * ave * l.Count) / Math.Max(1, l.Count - 1))
        End Sub
    End Class
    ''' NXg
    Public Class LinkList
        Private Class Enumrt
            Implements IEnumerator
            Private cur As Data
            Private top As Data
            Public Sub New(ByVal d As Data)
                top = d
                Reset()
            End Sub
            Public Sub Reset() Implements IEnumerator.Reset
                cur = top
            End Sub
            Public ReadOnly Property Current() As Object Implements IEnumerator.Current
                Get
                    Return cur.dat
                End Get
            End Property
            Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext
                If (cur.nxt Is Nothing) Then Return False
                cur = cur.nxt
                Return True
            End Function
        End Class
        Private Class Data
            Public dat As Object
            Public nxt As Data
            Public Sub New(ByVal o As Object)
                dat = o
                nxt = Nothing
            End Sub
        End Class
        Private n As Integer
        Private dt As Data
        Public Sub New()
            n = 0
            dt = New Data(Nothing)
        End Sub
        Public ReadOnly Property Count() As Integer
            Get
                Return n
            End Get
        End Property
        Public Sub Add(ByVal o As Object)
            Dim p As Data = dt
            While (Not p.nxt Is Nothing)
                p = p.nxt
            End While
            p.nxt = New Data(o)
            n += 1
        End Sub
        Public Function GetEnumerator() As IEnumerator
            Return New Enumrt(dt)
        End Function
    End Class
End Namespace
