Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization

Namespace PSP
    ''' ۑF10A
    '''     dAɂ90%70%̗\
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    Public Class C10A
#If C10A Then
        ''' 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
        ''' 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
        Shared Sub Main(ByVal args() As String)
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "10A", AddressOf Main, False)
                Exit Sub
            End If
            Dim l As LinkList = New LinkList()
            Dim est As Estimate
            If (Not ReadData(args(0), l, est)) Then Return
            If (l.Count <= 4) Then Return
            WriteResult(l, est)
        End Sub
#End If
        Public Class Estimate
            Public NewLOC As Integer
            Public ReuseLOC As Integer
            Public UpdateLOC As Integer
        End Class
        Public Class LOC
            Public No As Integer
            Public NewLOC As Integer
            Public ReuseLOC As Integer
            Public UpdateLOC As Integer
            Public Time As Double
        End Class
        Public Class Data
            Public Estimate As Estimate
            Public ArrayOfLOC() As LOC
        End Class
        ''' t@Cf[^Ǎ݂܂B
        Public Shared Function ReadData(ByVal fnam As String, ByVal l As LinkList, ByRef est As Estimate)
            Dim data As Data
            Try ' t@CJ
                Dim xr As XmlSerializer = New XmlSerializer(GetType(Data))
                Dim sr As StreamReader = New StreamReader(fnam)
                data = CType(xr.Deserialize(sr), Data)
                sr.Close()
            Catch e As FileNotFoundException
                Console.Error.WriteLine(e.Message)
                Return False
            End Try
            Dim d As Loc
            For Each d In data.ArrayOfLOC
                l.Add(d)
            Next
            est = data.Estimate
            Return True
        End Function
        Public Shared Sub WriteResult(ByVal l As LinkList, ByVal est As Estimate)
            Dim d, e, dlt, r, s, w, x, y, z, ww, wx, wy, wz, xx, xy, xz, yy, yz As Double
            Dim dt As Loc
            For Each dt In l
                w += dt.NewLOC
                x += dt.ReuseLOC
                y += dt.UpdateLOC
                z += dt.Time
                ww += dt.NewLOC * dt.NewLOC
                wx += dt.NewLOC * dt.ReuseLOC
                wy += dt.NewLOC * dt.UpdateLOC
                wz += dt.NewLOC * dt.Time
                xx += dt.ReuseLOC * dt.ReuseLOC
                xy += dt.ReuseLOC * dt.UpdateLOC
                xz += dt.ReuseLOC * dt.Time
                yy += dt.UpdateLOC * dt.UpdateLOC
                yz += dt.UpdateLOC * dt.Time
            Next
            Dim i, j, k, n As Integer
            n = l.Count
            Dim b(3) As Double
            Dim a(,) As Double = New Double(3, 4) {{n, w, x, y, z}, {w, ww, wx, wy, wz}, {x, wx, xx, xy, xz}, {y, wy, xy, yy, yz}}
            For i = 0 To 3
                For j = i + 1 To 4
                    a(i, j) /= a(i, i)
                Next
                For j = i + 1 To 3
                    For k = i + 1 To 4
                        a(j, k) -= a(i, k) * a(j, i)
                    Next
                Next
            Next
            For i = 3 To 1 Step -1
                For j = 0 To i - 1
                    a(j, 4) -= a(i, 4) * a(j, i)
                Next
            Next
            For i = 0 To 3
                b(i) = a(i, 4)
            Next
            dlt = 0
            For Each dt In l
                d = dt.Time - b(0) - b(1) * dt.NewLOC - b(2) * dt.ReuseLOC - b(3) * dt.UpdateLOC
                dlt += d * d
            Next
            dlt = Math.Sqrt(dlt / (n - 4))
            w /= n
            x /= n
            y /= n
            s = Math.Sqrt(1 + 1.0 / n + (est.NewLOC - w) * (est.NewLOC - w) / (ww - n * w * w) _
               + (est.ReuseLOC - x) * (est.ReuseLOC - x) / (xx - n * x * x) _
               + (est.UpdateLOC - y) * (est.UpdateLOC - y) / (yy - n * y * y))
            e = b(0) + b(1) * est.NewLOC + b(2) * est.ReuseLOC + b(3) * est.UpdateLOC
            Console.WriteLine("0 {0:F5}" + vbCrLf + "1 {1:F5}" + vbCrLf + "2 {2:F5}" _
                + vbCrLf + "3 {3:F5}" + vbCrLf + "Est {4:F2}", b(0), b(1), b(2), b(3), e)
            Dim rr() As Double = {0.7, 0.9}
            For Each r In rr
                Dim g As Double = dlt * s * CalcRevT(0.5 + r / 2, l.Count - 4)
                Console.WriteLine("{0}% {1:F2} ` {2:F2}", CType(r * 100 + 0.5, Integer), e - g, e + g)
            Next
        End Sub
        Public Shared Function FuncT(ByVal x As Double, ByVal o As Object) As Double
            Dim n As Integer = CType(o, Integer)
            Return Math.Pow(1 + x * x / n, -(n + 1) / 2.0)
        End Function
        Public Shared Function GFunc(ByVal x As Double, ByVal n As Integer) As Double
            Return 0.5 + Math.Exp(lngamma((n + 1) / 2.0) - lngamma(n / 2.0)) / Math.Sqrt(n * Math.PI) _
                * C05A.Simpson(AddressOf FuncT, 0, x, n)
        End Function
        Public Shared Function CalcRevT(ByVal x As Double, ByVal n As Integer) As Double
            Dim v, m, lo, up As Double
            up = 3
            Dim cnt As Integer
            While (GFunc(up, n) < x)
                up *= 2
            End While
            While (up - lo > 0.00000001 AndAlso ++cnt < 64)
                m = (up + lo) / 2
                v = GFunc(m, n)
                If (v < x) Then
                    lo = m
                Else
                    up = m
                End If
            End While
            Return m
        End Function
        ''' (x) = Math.Exp(lngamma(x))
        Public Shared Function lngamma(ByVal xx As Double) As Double
            Dim cof As Double() = {76.18009173, -86.50532033, 24.01409822, _
             -1.231739516, 0.00120858003, -0.00000536382}
            Dim x As Double = xx - 1.0
            Dim tmp As Double = x + 5.5
            tmp -= (x + 0.5) * Math.Log(tmp)
            Dim ser As Double = 1.0
            Dim j As Integer
            For j = 0 To 5
                x += 1.0
                ser += cof(j) / x
            Next
            Return -tmp + Math.Log(2.50662827465 * ser)
        End Function
    End Class
End Namespace
